]> git.proxmox.com Git - mirror_qemu.git/blame - tests/qemu-iotests/common.rc
block: Remove NULL check in bdrv_co_flush
[mirror_qemu.git] / tests / qemu-iotests / common.rc
CommitLineData
908eaf68 1#!/bin/bash
6bf19c94
CH
2#
3# Copyright (C) 2009 Red Hat, Inc.
4# Copyright (c) 2000-2006 Silicon Graphics, Inc. All Rights Reserved.
5#
6# This program is free software; you can redistribute it and/or modify
7# it under the terms of the GNU General Public License as published by
8# the Free Software Foundation; either version 2 of the License, or
9# (at your option) any later version.
10#
11# This program is distributed in the hope that it will be useful,
12# but WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14# GNU General Public License for more details.
15#
16# You should have received a copy of the GNU General Public License
e8c212d6 17# along with this program. If not, see <http://www.gnu.org/licenses/>.
6bf19c94
CH
18#
19
20dd()
21{
22 if [ "$HOSTOS" == "Linux" ]
79e40ab1
KW
23 then
24 command dd --help | grep noxfer > /dev/null 2>&1
25
26 if [ "$?" -eq 0 ]
27 then
28 command dd status=noxfer $@
29 else
30 command dd $@
31 fi
6bf19c94 32 else
79e40ab1 33 command dd $@
6bf19c94
CH
34 fi
35}
36
23ea2ecc
SH
37# poke_file 'test.img' 512 '\xff\xfe'
38poke_file()
39{
40 printf "$3" | dd "of=$1" bs=1 "seek=$2" conv=notrunc &>/dev/null
41}
42
6bf19c94
CH
43# we need common.config
44if [ "$iam" != "check" ]
45then
46 if ! . ./common.config
47 then
48 echo "$iam: failed to source common.config"
49 exit 1
50 fi
51fi
52
53# make sure we have a standard umask
54umask 022
55
076003f5
DB
56if [ "$IMGOPTSSYNTAX" = "true" ]; then
57 DRIVER="driver=$IMGFMT"
4e9b25fb
DB
58 if [ "$IMGFMT" = "luks" ]; then
59 DRIVER="$DRIVER,key-secret=keysec0"
60 fi
076003f5
DB
61 if [ "$IMGPROTO" = "file" ]; then
62 TEST_IMG_FILE=$TEST_DIR/t.$IMGFMT
63 TEST_IMG="$DRIVER,file.filename=$TEST_DIR/t.$IMGFMT"
64 elif [ "$IMGPROTO" = "nbd" ]; then
65 TEST_IMG_FILE=$TEST_DIR/t.$IMGFMT
66 TEST_IMG="$DRIVER,file.driver=nbd,file.host=127.0.0.1,file.port=10810"
67 elif [ "$IMGPROTO" = "ssh" ]; then
68 TEST_IMG_FILE=$TEST_DIR/t.$IMGFMT
69 TEST_IMG="$DRIVER,file.driver=ssh,file.host=127.0.0.1,file.path=$TEST_IMG_FILE"
70 elif [ "$IMGPROTO" = "nfs" ]; then
71 TEST_DIR="$DRIVER,file.driver=nfs,file.filename=nfs://127.0.0.1/$TEST_DIR"
e5b77eec 72 TEST_IMG=$TEST_DIR/t.$IMGFMT
076003f5
DB
73 else
74 TEST_IMG="$DRIVER,file.driver=$IMGPROTO,file.filename=$TEST_DIR/t.$IMGFMT"
75 fi
9cdfa1b3 76else
076003f5
DB
77 if [ "$IMGPROTO" = "file" ]; then
78 TEST_IMG=$TEST_DIR/t.$IMGFMT
79 elif [ "$IMGPROTO" = "nbd" ]; then
80 TEST_IMG_FILE=$TEST_DIR/t.$IMGFMT
81 TEST_IMG="nbd:127.0.0.1:10810"
82 elif [ "$IMGPROTO" = "ssh" ]; then
83 TEST_IMG_FILE=$TEST_DIR/t.$IMGFMT
84 TEST_IMG="ssh://127.0.0.1$TEST_IMG_FILE"
85 elif [ "$IMGPROTO" = "nfs" ]; then
86 TEST_DIR="nfs://127.0.0.1/$TEST_DIR"
87 TEST_IMG=$TEST_DIR/t.$IMGFMT
ae0c0a3d
AM
88 elif [ "$IMGPROTO" = "vxhs" ]; then
89 TEST_IMG_FILE=$TEST_DIR/t.$IMGFMT
90 TEST_IMG="vxhs://127.0.0.1:9999/t.$IMGFMT"
076003f5
DB
91 else
92 TEST_IMG=$IMGPROTO:$TEST_DIR/t.$IMGFMT
93 fi
9cdfa1b3 94fi
6bf19c94 95
89004368
KW
96_optstr_add()
97{
98 if [ -n "$1" ]; then
99 echo "$1,$2"
100 else
101 echo "$2"
102 fi
103}
104
105_set_default_imgopts()
106{
107 if [ "$IMGFMT" == "qcow2" ] && ! (echo "$IMGOPTS" | grep "compat=" > /dev/null); then
108 IMGOPTS=$(_optstr_add "$IMGOPTS" "compat=1.1")
109 fi
110}
111
85edbd37
JC
112_use_sample_img()
113{
114 SAMPLE_IMG_FILE="${1%\.bz2}"
115 TEST_IMG="$TEST_DIR/$SAMPLE_IMG_FILE"
116 bzcat "$SAMPLE_IMG_DIR/$1" > "$TEST_IMG"
117 if [ $? -ne 0 ]
118 then
119 echo "_use_sample_img error, cannot extract '$SAMPLE_IMG_DIR/$1'"
120 exit 1
121 fi
122}
123
6bf19c94
CH
124_make_test_img()
125{
126 # extra qemu-img options can be added by tests
127 # at least one argument (the image size) needs to be added
21af8148 128 local extra_img_options=""
21af8148 129 local image_size=$*
89004368 130 local optstr=""
a9660664 131 local img_name=""
0018c03f
JC
132 local use_backing=0
133 local backing_file=""
b7e875b2 134 local object_options=""
a9660664
NT
135
136 if [ -n "$TEST_IMG_FILE" ]; then
137 img_name=$TEST_IMG_FILE
138 else
139 img_name=$TEST_IMG
140 fi
89004368
KW
141
142 if [ -n "$IMGOPTS" ]; then
143 optstr=$(_optstr_add "$optstr" "$IMGOPTS")
144 fi
b7e875b2
DB
145 if [ -n "$IMGKEYSECRET" ]; then
146 object_options="--object secret,id=keysec0,data=$IMGKEYSECRET"
147 optstr=$(_optstr_add "$optstr" "key-secret=keysec0")
148 fi
6bf19c94 149
21af8148 150 if [ "$1" = "-b" ]; then
0018c03f
JC
151 use_backing=1
152 backing_file=$2
21af8148
SW
153 image_size=$3
154 fi
f5a4bbd9 155 if [ \( "$IMGFMT" = "qcow2" -o "$IMGFMT" = "qed" \) -a -n "$CLUSTER_SIZE" ]; then
89004368
KW
156 optstr=$(_optstr_add "$optstr" "cluster_size=$CLUSTER_SIZE")
157 fi
158
159 if [ -n "$optstr" ]; then
160 extra_img_options="-o $optstr $extra_img_options"
8fc1024c
KW
161 fi
162
6bf19c94 163 # XXX(hch): have global image options?
0018c03f
JC
164 (
165 if [ $use_backing = 1 ]; then
b7e875b2 166 $QEMU_IMG create $object_options -f $IMGFMT $extra_img_options -b "$backing_file" "$img_name" $image_size 2>&1
0018c03f 167 else
b7e875b2 168 $QEMU_IMG create $object_options -f $IMGFMT $extra_img_options "$img_name" $image_size 2>&1
0018c03f 169 fi
6ffb4cb6 170 ) | _filter_img_create
a9660664
NT
171
172 # Start an NBD server on the image file, which is what we'll be talking to
173 if [ $IMGPROTO = "nbd" ]; then
43421ea0 174 eval "$QEMU_NBD -v -t -b 127.0.0.1 -p 10810 -f $IMGFMT $TEST_IMG_FILE >/dev/null &"
a9660664
NT
175 sleep 1 # FIXME: qemu-nbd needs to be listening before we continue
176 fi
ae0c0a3d
AM
177
178 # Start QNIO server on image directory for vxhs protocol
179 if [ $IMGPROTO = "vxhs" ]; then
180 eval "$QEMU_VXHS -d $TEST_DIR > /dev/null &"
181 sleep 1 # Wait for server to come up.
182 fi
6bf19c94
CH
183}
184
487c1910
FZ
185_rm_test_img()
186{
187 local img=$1
188 if [ "$IMGFMT" = "vmdk" ]; then
189 # Remove all the extents for vmdk
c5575274 190 "$QEMU_IMG" info "$img" 2>/dev/null | grep 'filename:' | cut -f 2 -d: \
487c1910
FZ
191 | xargs -I {} rm -f "{}"
192 fi
c5575274 193 rm -f "$img"
487c1910
FZ
194}
195
6bf19c94
CH
196_cleanup_test_img()
197{
9cdfa1b3
MK
198 case "$IMGPROTO" in
199
a9660664 200 nbd)
846a1d11 201 if [ -f "${QEMU_TEST_DIR}/qemu-nbd.pid" ]; then
f6c8c2e0 202 local QEMU_NBD_PID
846a1d11 203 read QEMU_NBD_PID < "${QEMU_TEST_DIR}/qemu-nbd.pid"
f6c8c2e0 204 kill ${QEMU_NBD_PID}
846a1d11 205 rm -f "${QEMU_TEST_DIR}/qemu-nbd.pid"
f798068c 206 fi
fef9c191 207 rm -f "$TEST_IMG_FILE"
a9660664 208 ;;
ae0c0a3d
AM
209 vxhs)
210 if [ -f "${TEST_DIR}/qemu-vxhs.pid" ]; then
211 local QEMU_VXHS_PID
212 read QEMU_VXHS_PID < "${TEST_DIR}/qemu-vxhs.pid"
213 kill ${QEMU_VXHS_PID} >/dev/null 2>&1
214 rm -f "${TEST_DIR}/qemu-vxhs.pid"
215 fi
216 rm -f "$TEST_IMG_FILE"
217 ;;
218
9cdfa1b3 219 file)
487c1910
FZ
220 _rm_test_img "$TEST_DIR/t.$IMGFMT"
221 _rm_test_img "$TEST_DIR/t.$IMGFMT.orig"
222 _rm_test_img "$TEST_DIR/t.$IMGFMT.base"
85edbd37
JC
223 if [ -n "$SAMPLE_IMG_FILE" ]
224 then
225 rm -f "$TEST_DIR/$SAMPLE_IMG_FILE"
226 fi
9cdfa1b3
MK
227 ;;
228
229 rbd)
9147d019 230 rbd --no-progress rm "$TEST_DIR/t.$IMGFMT" > /dev/null
9cdfa1b3
MK
231 ;;
232
233 sheepdog)
fef9c191 234 collie vdi delete "$TEST_DIR/t.$IMGFMT"
9cdfa1b3
MK
235 ;;
236
237 esac
6bf19c94
CH
238}
239
240_check_test_img()
241{
076003f5
DB
242 (
243 if [ "$IMGOPTSSYNTAX" = "true" ]; then
244 $QEMU_IMG check $QEMU_IMG_EXTRA_ARGS "$@" "$TEST_IMG" 2>&1
245 else
246 $QEMU_IMG check "$@" -f $IMGFMT "$TEST_IMG" 2>&1
247 fi
86ce1f6e 248 ) | _filter_testdir | _filter_qemu_img_check
6bf19c94
CH
249}
250
514d9da5
SH
251_img_info()
252{
e800e5d4
KW
253 if [[ "$1" == "--format-specific" ]]; then
254 local format_specific=1
255 shift
256 else
257 local format_specific=0
258 fi
259
4c2e9465
HR
260 discard=0
261 regex_json_spec_start='^ *"format-specific": \{'
fef9c191 262 $QEMU_IMG info "$@" "$TEST_IMG" 2>&1 | \
514d9da5
SH
263 sed -e "s#$IMGPROTO:$TEST_DIR#TEST_DIR#g" \
264 -e "s#$TEST_DIR#TEST_DIR#g" \
265 -e "s#$IMGFMT#IMGFMT#g" \
266 -e "/^disk size:/ D" \
4c2e9465
HR
267 -e "/actual-size/ D" | \
268 while IFS='' read line; do
e800e5d4
KW
269 if [[ $format_specific == 1 ]]; then
270 discard=0
271 elif [[ $line == "Format specific information:" ]]; then
4c2e9465
HR
272 discard=1
273 elif [[ $line =~ $regex_json_spec_start ]]; then
274 discard=2
275 regex_json_spec_end="^${line%%[^ ]*}\\},? *$"
276 fi
277 if [[ $discard == 0 ]]; then
278 echo "$line"
279 elif [[ $discard == 1 && ! $line ]]; then
280 echo
281 discard=0
282 elif [[ $discard == 2 && $line =~ $regex_json_spec_end ]]; then
283 discard=0
284 fi
285 done
514d9da5
SH
286}
287
6bf19c94
CH
288_get_pids_by_name()
289{
290 if [ $# -ne 1 ]
291 then
79e40ab1
KW
292 echo "Usage: _get_pids_by_name process-name" 1>&2
293 exit 1
6bf19c94
CH
294 fi
295
296 # Algorithm ... all ps(1) variants have a time of the form MM:SS or
297 # HH:MM:SS before the psargs field, use this as the search anchor.
298 #
299 # Matches with $1 (process-name) occur if the first psarg is $1
300 # or ends in /$1 ... the matching uses sed's regular expressions,
301 # so passing a regex into $1 will work.
302
303 ps $PS_ALL_FLAGS \
304 | sed -n \
79e40ab1
KW
305 -e 's/$/ /' \
306 -e 's/[ ][ ]*/ /g' \
307 -e 's/^ //' \
308 -e 's/^[^ ]* //' \
309 -e "/[0-9]:[0-9][0-9] *[^ ]*\/$1 /s/ .*//p" \
310 -e "/[0-9]:[0-9][0-9] *$1 /s/ .*//p"
6bf19c94
CH
311}
312
313# fqdn for localhost
314#
315_get_fqdn()
316{
317 host=`hostname`
318 $NSLOOKUP_PROG $host | $AWK_PROG '{ if ($1 == "Name:") print $2 }'
319}
320
321# check if run as root
322#
323_need_to_be_root()
324{
325 id=`id | $SED_PROG -e 's/(.*//' -e 's/.*=//'`
326 if [ "$id" -ne 0 ]
327 then
79e40ab1
KW
328 echo "Arrgh ... you need to be root (not uid=$id) to run this test"
329 exit 1
6bf19c94
CH
330 fi
331}
332
6bf19c94
CH
333# bail out, setting up .notrun file
334#
335_notrun()
336{
e8f8624d 337 echo "$*" >"$OUTPUT_DIR/$seq.notrun"
6bf19c94
CH
338 echo "$seq not run: $*"
339 status=0
340 exit
341}
342
343# just plain bail out
344#
345_fail()
346{
e8f8624d 347 echo "$*" | tee -a "$OUTPUT_DIR/$seq.full"
6bf19c94
CH
348 echo "(see $seq.full for details)"
349 status=1
350 exit 1
351}
352
353# tests whether $IMGFMT is one of the supported image formats for a test
354#
355_supported_fmt()
356{
47f73da0
SH
357 # "generic" is suitable for most image formats. For some formats it doesn't
358 # work, however (most notably read-only formats), so they can opt out by
359 # setting IMGFMT_GENERIC to false.
6bf19c94 360 for f; do
89e91181 361 if [ "$f" = "$IMGFMT" -o "$f" = "generic" -a "$IMGFMT_GENERIC" = "true" ]; then
79e40ab1
KW
362 return
363 fi
6bf19c94
CH
364 done
365
366 _notrun "not suitable for this image format: $IMGFMT"
367}
368
b4a2caa4
NS
369# tests whether $IMGFMT is one of the unsupported image format for a test
370#
371_unsupported_fmt()
372{
373 for f; do
374 if [ "$f" = "$IMGFMT" ]; then
375 _notrun "not suitable for this image format: $IMGFMT"
376 fi
377 done
378}
379
9cdfa1b3
MK
380# tests whether $IMGPROTO is one of the supported image protocols for a test
381#
382_supported_proto()
383{
384 for f; do
79e40ab1
KW
385 if [ "$f" = "$IMGPROTO" -o "$f" = "generic" ]; then
386 return
387 fi
9cdfa1b3
MK
388 done
389
390 _notrun "not suitable for this image protocol: $IMGPROTO"
391}
392
dfac03dc
JC
393# tests whether $IMGPROTO is specified as an unsupported image protocol for a test
394#
395_unsupported_proto()
396{
397 for f; do
398 if [ "$f" = "$IMGPROTO" ]; then
399 _notrun "not suitable for this image protocol: $IMGPROTO"
400 return
401 fi
402 done
403}
404
6bf19c94
CH
405# tests whether the host OS is one of the supported OSes for a test
406#
407_supported_os()
408{
409 for h
410 do
79e40ab1
KW
411 if [ "$h" = "$HOSTOS" ]
412 then
413 return
414 fi
6bf19c94
CH
415 done
416
417 _notrun "not suitable for this OS: $HOSTOS"
418}
419
f210a83c 420_supported_cache_modes()
166f3c7b 421{
f210a83c
FZ
422 for mode; do
423 if [ "$mode" = "$CACHEMODE" ]; then
424 return
425 fi
166f3c7b 426 done
f210a83c
FZ
427 _notrun "not suitable for cache mode: $CACHEMODE"
428}
429
430_default_cache_mode()
431{
432 if $CACHEMODE_IS_DEFAULT; then
433 CACHEMODE="$1"
434 QEMU_IO="$QEMU_IO --cache $1"
435 return
436 fi
166f3c7b
SH
437}
438
2c77f52e
FZ
439_unsupported_imgopts()
440{
441 for bad_opt
442 do
443 if echo "$IMGOPTS" | grep -q 2>/dev/null "$bad_opt"
444 then
445 _notrun "not suitable for image option: $bad_opt"
446 fi
447 done
448}
449
6bf19c94
CH
450# this test requires that a specified command (executable) exists
451#
452_require_command()
453{
934659c4
HR
454 if [ "$1" = "QEMU" ]; then
455 c=$QEMU_PROG
456 elif [ "$1" = "QEMU_IMG" ]; then
457 c=$QEMU_IMG_PROG
458 elif [ "$1" = "QEMU_IO" ]; then
459 c=$QEMU_IO_PROG
460 elif [ "$1" = "QEMU_NBD" ]; then
461 c=$QEMU_NBD_PROG
462 else
463 eval c=\$$1
464 fi
9c468a01 465 [ -x "$c" ] || _notrun "$1 utility required, skipped this test"
6bf19c94
CH
466}
467
468_full_imgfmt_details()
469{
89004368
KW
470 if [ -n "$IMGOPTS" ]; then
471 echo "$IMGFMT ($IMGOPTS)"
472 else
473 echo "$IMGFMT"
474 fi
6bf19c94
CH
475}
476
9cdfa1b3
MK
477_full_imgproto_details()
478{
479 echo "$IMGPROTO"
480}
481
6bf19c94
CH
482_full_platform_details()
483{
484 os=`uname -s`
485 host=`hostname -s`
486 kernel=`uname -r`
487 platform=`uname -m`
488 echo "$os/$platform $host $kernel"
489}
490
491_link_out_file()
492{
493 if [ -z "$1" ]; then
494 echo Error must pass \$seq.
495 exit
496 fi
497 rm -f $1
498 if [ "`uname`" == "IRIX64" ] || [ "`uname`" == "IRIX" ]; then
499 ln -s $1.irix $1
500 elif [ "`uname`" == "Linux" ]; then
501 ln -s $1.linux $1
502 else
503 echo Error test $seq does not run on the operating system: `uname`
504 exit
505 fi
506}
507
508_die()
509{
510 echo $@
511 exit 1
512}
513
514# make sure this script returns success
a2d9c0c4 515true